//Weapon_Gls_Slash.cs

//effects
datablock ParticleData(TuskAttackHitParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	colors[0]     = "0.654206 0.785047 1 1";
	colors[1]     = "1.0 1.0 1.0 0.7";
//	colors[2]     = "0.2 0.6 0.0 0.1";
	sizes[0]      = 0.4;
	sizes[1]      = 0.8;
//	sizes[2]      = 0.1;
	times[0]	  = 0.0;
	times[1]	  = 1.00;
//	times[2]	  = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(TuskAttackHitEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 3;
   ejectionVelocity = 10;
   velocityVariance = 2.0;
   ejectionOffset   = 0.3;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TuskAttackHitParticle";

   uiName = "";
};

datablock ExplosionData(TuskAttackExplosion)
{
   explosionShape = "base/data/shapes/empty.dts";
   lifeTimeMS = 500;

   soundProfile = swordHitSound;

   particleEmitter = TuskAttackHitEmitter;
   particleDensity = 12;
   particleRadius = 0.1;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "4.0 4.0 4.0";
   camShakeAmp = "20.0 15.0 7.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   	impulseRadius = 3.5;
	impulseForce = 2500;

	damageRadius = 0.01;
	radiusDamage = 0.01;

};


//projectile
AddDamageType("Mitebite",   '<bitmap:add-ons/Bot_Elephant/CI_Elephant> %1',    '%2 <bitmap:add-ons/Bot_Elephant/CI_Elephant> %1',0.75,1);
datablock ProjectileData(TuskAttackProjectile) // : BugBitePtojectile)
{
   directDamage        = 50;	//25
   directDamageType  = $DamageType::Mitebite;
   radiusDamageType  = $DamageType::Mitebite;
   explosion           = TuskAttackExplosion;

	impactImpulse	   = 500;
	verticalImpulse	   = 500;

   muzzleVelocity      = 145;	//130
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

//   hasLight    = false;
//   lightRadius = 3.0;
//   lightColor  = "0 0 0.5";

   uiName = "";
};


//////////
// item //
//////////
datablock ItemData(TuskAttackItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Elephant Attack";
//	iconName = "./icon_TuskAttack";
//	doColorShift = false;
//	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = TuskAttackImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TuskAttackImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = TuskAttackProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

   //casing = " ";
//   doColorShift = false;
//   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]      = "Ready";
//	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Windup";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Windup";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.25;		//0.3
//	stateFire[2]                    = false;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onWindup";
	stateWaitForTimeout[2]		= true;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Recharge";
	stateTimeoutValue[3]            = 0.5;		//0.32
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
//	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

//	stateName[4]			= "CheckFire";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";
	
	stateName[4]                    = "Recharge";
//	stateTransitionOnTimeout[3]     = "Ready";
//	stateTimeoutValue[3]            = 0.25;
	stateAllowImageChange[4]        = false;
//	stateWaitForTimeout[3]			= true;
//	stateSequence[3]                = "StopFire";
//	stateScript[3]                  = "onStopFire";
	stateTransitionOnTriggerUp[4]	= "Ready";

};


function TuskAttackImage::onWindup(%this, %obj, %slot)
{
		%obj.playthread(0, jump);
}

function TuskAttackImage::onFire(%this, %obj, %slot)
{
//	if(getRandom(0,1))
//	{
//		%obj.playthread(2, plant);
//	}
//	else 
//	if(getRandom(0,1))
//	{
//	}
//	else
//	{
//		%obj.playthread(2, plant);
//	}
	Parent::onFire(%this,%obj,%slot);
}
