datablock TSShapeConstructor(ElephantDts)
{
	baseShape  = "./Elephant.dts";
	sequence0  = "./Elephant_root.dsq root";

	sequence1  = "./Elephant_run.dsq run";
	sequence2  = "./Elephant_run.dsq walk";
	sequence3  = "./Elephant_back.dsq back";
	sequence4  = "./Elephant_run.dsq side";

	sequence5  = "./Elephant_root.dsq crouch";
	sequence6  = "./Elephant_speed.dsq crouchRun";
	sequence7  = "./Elephant_back.dsq crouchBack";
	sequence8  = "./Elephant_speed.dsq crouchSide";

	sequence9  = "./Elephant_look.dsq look";
	sequence10 = "./Elephant_headside.dsq headside";
	sequence11 = "./Elephant_look.dsq headUp";

	sequence12 = "./Elephant_attack.dsq jump";
	sequence13 = "./Elephant_attack.dsq standjump";
	sequence14 = "./Elephant_fall.dsq fall";
	sequence15 = "./Elephant_land.dsq land";

	sequence16 = "./Elephant_attack.dsq armAttack";
	sequence17 = "./Elephant_activate2.dsq armReadyLeft";
	sequence18 = "./Elephant_root.dsq armReadyRight";
	sequence19 = "./Elephant_root.dsq armReadyBoth";
	sequence20 = "./Elephant_Root.dsq spearready";  
	sequence21 = "./Elephant_root.dsq spearThrow";

	sequence22 = "./Elephant_activate.dsq talk";  

	sequence23 = "./Elephant_death.dsq death1"; 
	
	sequence24 = "./Elephant_anim.dsq shiftUp";
	sequence25 = "./Elephant_root.dsq shiftDown";
	sequence26 = "./Elephant_root.dsq shiftAway";
	sequence27 = "./Elephant_root.dsq shiftTo";
	sequence28 = "./Elephant_root.dsq shiftLeft";
	sequence29 = "./Elephant_root.dsq shiftRight";
	sequence30 = "./Elephant_root.dsq rotCW";
	sequence31 = "./Elephant_root.dsq rotCCW";

	sequence32 = "./Elephant_root.dsq undo";
	sequence33 = "./Elephant_root.dsq plant";

	sequence34 = "./Elephant_sit.dsq sit";

	sequence35 = "./Elephant_root.dsq wrench";

   sequence36 = "./Elephant_activate.dsq activate";
   sequence37 = "./Elephant_attack.dsq activate2";

   sequence38 = "./Elephant_root.dsq leftrecoil";
};  
datablock AudioProfile(ElephantHoleBotDeathSound)
{
	fileName = "./death.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(ElephantHoleBotPainSound)
{
    fileName = "./pain.wav";
    description = AudioClose3d;
    preload = true;
};
datablock AudioProfile(ElephantSoundEffect1Sound)
{
	fileName = "./ElephantTrumpet1.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(ElephantSoundEffect2Sound)
{
   filename    = "./ElephantTrumpet2.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(ElephantSoundEffect3Sound)
{
   filename    = "./ElephantTrumpet3.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(ElephantSoundEffect4Sound)
{
   filename    = "./ElephantTrumpet4.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock DebrisData( ElephantDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};       

datablock fxDTSBrickData (BrickElephantBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/8xspawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Elephant Hole";
	iconName = "Add-Ons/Bot_Elephant/icon_Elephant";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "ElephantHoleBot";
};

// when the Elephant brick is initially planted hide it, as most of the time we don't want it to exist since we're in the water
function BrickElephantBot_HoleSpawnData::onPlant( %this, %obj )
{
	%obj.setRendering(0);
	%obj.setColliding(0);
	%obj.setRaycasting(0);
}

//Elephant melee icon
AddDamageType("ElephantHoleBite",   '<bitmap:Add-Ons/Bot_Elephant/CI_Elephant> %1',    '%2 <bitmap:Add-Ons/Bot_Elephant/CI_Elephant> %1',0.5,1);


datablock PlayerData(ElephantHoleBot : PlayerStandardArmor)
{
	shapeFile = "./Elephant.dts";
	uiName = "Elephant";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 0;
	maxWeapons = 0;
	maxTools = 0;

	rideable = true;
		lookUpLimit = 0.6;
		lookDownLimit = 0.2;
	canRide = false;
	paintable = false;
	
	useCustomPainEffects = true;
    PainSound			= ElephantHoleBotPainSound;
    DeathSound			= ElephantHoleBotDeathSound;

	mass = 500;
	drag = 0.02;//0.02
	density = 0.80;//0.6
	runSurfaceAngle = 70;
	jumpSurfaceAngle = 70;
    runForce = 90 * 90;
   
   maxForwardSpeed = 5;
   maxBackwardSpeed = 5;
   maxSideSpeed = 2;

   maxForwardCrouchSpeed = 10;
   maxBackwardCrouchSpeed = 5;
   maxSideCrouchSpeed = 4;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 5;
   maxBackwardWalkSpeed = 5;
   maxSideWalkSpeed = 2;

   maxUnderwaterForwardSpeed = 3;
   maxUnderwaterBackwardSpeed = 3;
   maxUnderwaterSideSpeed = 2;

   renderFirstPerson = false;
   emap = false;
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   cameraVerticalOffset = 2.3;
  cameraMaxDist = 8;


   aiAvoidThis = true;   
	maxStepHeight = 2;
	jumpForce = 0;
	showEnergyBar = false;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;
   pickupRadius = 0.75;

   numMountPoints = 1;
   mountNode[0] = 2;
   mountThread[0] = "sit";
   mountThread[2] = "sit"; 

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;



	boundingBox			= vectorScale("4.35 4.35 6.7", 3); //"2.5 2.5 2.4";
	crouchBoundingBox	= vectorScale("4.35 4.35 6.7", 3); //"2.5 2.5 2.4";
	proneBoundingBox	= vectorScale("4.35 4.35 6.7", 3); //"2.5 2.5 2.4";

	maxdamage = 600;//Bot Health
	jumpSound = "";//Removed due to bots jumping a lot
	
	//Hole Attributes
	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Neutral; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 40;
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Elephant";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 64;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRadius = 6;//max 10
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 45;//Melee Damage
	  	  hMeleeCI = "ElephantHoleBite";
	hShoot = 0;
	  hWep = "";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 256;//The range in which the bot will shoot the player
	  hAvoidCloseRange = 1;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 0;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 1;
};

function ElephantHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);
	%obj.mountimage(TuskAttackImage,0);
	%color[%a++] = "0.38785 0.401869 0.453271 1";
	%color[%a++] = "0.616822 0.626168 0.630841 1";
	%color[%a++] = "0.630841 0.602804 0.61215 1";
	%color[%a++] = "0.453271 0.434579 0.439252 1";
	%color[%a++] = "0.457944 0.397196 0.294393 1";
	%color[%a++] = "0.733645 0.700935 0.593458 1";

   // Vehicle timeout
   %obj.mountVehicle = true;

   // Default dynamic armor stats
   %obj.setRepairRate(0);

	%choice = getRandom(1,%a);
	%obj.setNodeColor("ALL",%color[%choice]);
	%obj.setNodeColor("muzzle","0.70 0.55 0.35 1");
	%obj.chestColor =  %color[%choice];
	//scheduleNoQuota(10,%obj,delayElephantCheck,%obj);
	%obj.controlOnMount = 1;
}

function ElephantHoleBot::onTrigger(%this, %obj, %trig, %press){
	if(%trig == 4 && %press && %obj.getDatablock().getName() $= "ElephantHoleBot")
	{
		%obj.playThread(0, "armReadyLeft"); //animation
		serverPlay3D("ElephantSoundEffect" @ getRandom(1, 4) @ "Sound", %obj.getPosition());
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function ElephantHoleBot::onBotLoop(%this,%obj)
{
	//Called every cycle
	//Useful for doing unique behaviors during normal loop
}

function ElephantHoleBot::onBotCollision( %this, %obj, %col, %normal, %speed )
{
	//Called once every second the object is colliding with something
	//echo(%obj.isStampeding SPC %col.isHoleBot SPC %obj.getState() !$= "Dead" SPC %col.getState() !$= "Dead" SPC !%col.isStampeding SPC %col.getDataBlock().getName() $= "ElephantHoleBot");
	if(%obj.isStampeding && %col.isHoleBot && %obj.getState() !$= "Dead" && %col.getState() !$= "Dead" && !%col.isStampeding && %col.getDataBlock().getName() $= "ElephantHoleBot")
	{
		//echo("Spreading stampede");
		%col.emote("AlarmProjectile");
		%col.stopHoleLoop();
		hDoStampede(%col);
		scheduleNoQuota(2000+getRandom(-750,750),%col,hDoStampede,%col);
		scheduleNoQuota(4000+getRandom(-750,750),%col,hDoStampede,%col);
		scheduleNoQuota(6000,%col,hStopStampede,%col);
	}
}

function ElephantHoleBot::onBotFollow(%this,%obj,%targ)
{
	%obj.setCrouching(1);
	//Called when the target follows a player each tick, or is running away
}
function ElephantHoleBot::onBotDeath(%this,%obj,%targ)
{
	%obj.SetBotPowered(0);
	//
}
function ElephantHoleBot::onBotSpawn(%this,%obj,%targ)
{
	%obj.SetBotPowered(1);
	//
}
function ElephantHoleBot::onBotDamage(%this,%obj,%source,%pos,%damage,%type)
{
	//Called when the bot is being damaged
	if(!%obj.isStampeding && %obj.getState() !$= "Dead" && !%obj.hMelee)
	{
		%obj.stopHoleLoop();
		%obj.emote("AlarmProjectile");
		hDoStampede(%obj);
		scheduleNoQuota(2000+getRandom(-750,750),%obj,hDoStampede,%obj);
		scheduleNoQuota(4000+getRandom(-750,750),%obj,hDoStampede,%obj);
		scheduleNoQuota(6000,%obj,hStopStampede,%obj);
	}
	// %driver = %obj.getMountedObject(0);
	// if( isObject(%driver) && %obj.getDamagePercent() >= 0.5)
	// {
	// if( !getRandom( 0, 1 ) )
	if( %obj.getDamagePercent() >= 0.5 )
		%obj.scheduleNoQuota( 200, ejectRandomPlayer );
	// }
}
function hDoStampede(%obj)
{
	if(%obj.hMelee)
		return;
	
	// %obj.setImageTrigger(2,1);
	%obj.setJumping(1);
	%obj.setJetting(1);
	//%obj.setImageTrigger(2,0);

	%obj.isStampeding = 1;

	%x = hGetRandomFloat(0,10,1);

	%y = hGetRandomFloat(0,10,1);
	
	%z = hGetRandomFloat(0,3,1);

	%vec = %x SPC %y SPC %z;
	// hSetAimVector(%obj,%vec);
	%obj.setAimVector( %vec );

	%obj.setMoveY(1);//hGetRandomFloat(6,10,0));

	%obj.hAvoidObstacle();
	%obj.hDetectWall(1);
	// hAvoidObstacle(%obj);
	// hWanderSearchWall(%obj,1);

	//schedule(3000,%obj,hAvoidObstacle,%obj,1);
	
	//%obj.schedule(7000,startHoleLoop);
}

function hStopStampede(%obj)
{
	%obj.startHoleLoop();
	%obj.isStampeding = 0;
}
function ElephantHoleBot::onDriverLeave(%obj, %player)
{
	//do nothing
}